# DSPOptimizations Mod
This mod adds optimizations to DSP. Few optimizations are available currently, but more will be added in the future.

## Important Notice
The low resolution shells optimization is now obsolete with DSP v0.9. If you had lower resolution shells in your save, then the vanilla game will update them incorrectly. As of v1.0.6, this mod should update such modded shells correctly.

## Features
- Dense spheres with shells now impact the game's framerate much less
	- e.g. the framerate with a single sphere layer with 5240 shells with the game paused went from 8 fps to 24 fps
- Multithreading is added for the logic controlling belts going in and out of stations
		- this should greatly reduce the CPU time under the "Storage" category in the performance window
- Dyson node logic has been optimized to take 20% as long
- Hidden sphere layers under construction cause less lag
- Shadows can be disabled in the config

## Installation Note
This mod depends on [DSPModSave](https://dsp.thunderstore.io/package/CommonAPI/DSPModSave/). Make sure that you have the version under the CommonAPI name, rather than the old version released by crecheng. The old version has bugs, and may cause problems. The old version of the mod is marked as deprecated.

## Compatibility
This mod is most likely not compatible with the [Nebula Mod](https://dsp.thunderstore.io/package/nebula/NebulaMultiplayerModApi/), however compatibility will be added in the future.

## Bug Reports
If you encounter any bugs or issues, then please contact me either on discord at Selsion#0769, or by raising an issue on the [mod github page](https://github.com/Selsion/DSPMods/tree/main/DSPOptimizations).

## Changelog
- v1.1.2
	- added multithreading for station storage logic
- v1.1.1
	- improved fps for dense spheres by optimizing shell rendering
	- reduced lag caused by shader buffers being synced when a hidden layer is under construction
- v1.1.0
	- optimized dyson node logic
- v1.0.6
	- Removed the low resolution shells feature

## Attributions
Icon(s) made by [Freepik](https://www.freepik.com) from www.flaticon.com